Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0


Summary:        Web application framework for J2EE
Name:           webwork
Version:        2.2.7
Release:        alt2_1jpp5
Epoch:          0
License:        Apache Software License modified
URL:            http://www.opensymphony.com/webwork/
Group:          Development/Java
Source0:        webwork-2.2.7.zip
Source1:        webwork-LICENSE.txt
Patch0:         webwork-2.2.7-TilesResult.patch
Patch1:         webwork-2.2.7-PellMultiPartRequest.patch
Patch2:         webwork-2.2.7-ApplyDecoratorBean.patch
Patch3:         webwork-2.2.7-PlexusObjectFactory.patch
Patch4:         webwork-2.2.7-osbuild.patch
Patch5:         webwork-2.2.7-WebWorkMockPageContext.patch
Patch6:         webwork-2.2.7-MockFactory.patch

BuildRequires: jpackage-utils >= 0:1.7.3
BuildRequires: ant >= 0:1.6.5
BuildRequires: ant-junit
BuildRequires: ant-nodeps
BuildRequires: ant-trax
BuildRequires: antlr
BuildRequires: ivy
BuildRequires: junit >= 0:3.8.1
BuildRequires: jsch
BuildRequires: mockobjects
BuildRequires: mockobjects-alt-jdk1.4
BuildRequires: mockobjects-jdk1.4
BuildRequires: mockobjects-jdk1.4-j2ee1.4
BuildRequires: xmlunit
#
BuildRequires: asm
BuildRequires: cewolf
BuildRequires: cglib
BuildRequires: classworlds
BuildRequires: dom4j
BuildRequires: dwr
BuildRequires: ecj
BuildRequires: ehcache
BuildRequires: freemarker
BuildRequires: hibernate3
BuildRequires: itext
BuildRequires: jakarta-commons-attributes
BuildRequires: jakarta-commons-beanutils
BuildRequires: jakarta-commons-collections
BuildRequires: jakarta-commons-digester
BuildRequires: jakarta-commons-el
BuildRequires: jakarta-commons-fileupload
BuildRequires: jakarta-commons-io
BuildRequires: jakarta-commons-lang
BuildRequires: jakarta-commons-logging
BuildRequires: jakarta-poi
BuildRequires: jakarta-taglibs-standard
BuildRequires: jasperreports >= 0:1.0.0
BuildRequires: javamail_1_3_1_api
BuildRequires: javassist
BuildRequires: jcommon
BuildRequires: jetty5
BuildRequires: jfreechart >= 0:0.9.21
BuildRequires: jsp_2_0_api
BuildRequires: log4j
BuildRequires: nanocontainer
BuildRequires: nanocontainer-nanowar
BuildRequires: ognl
BuildRequires: oscore
BuildRequires: pell-multipart
BuildRequires: picocontainer
BuildRequires: plexus-container-default
BuildRequires: plexus-utils
BuildRequires: rife-continuations
BuildRequires: servlet_2_4_api
BuildRequires: sitemesh >= 0:2.4.1
BuildRequires: spring-aop
BuildRequires: spring-beans
BuildRequires: spring-context
BuildRequires: spring-core
BuildRequires: spring-mock
BuildRequires: spring-web
BuildRequires: struts-tiles
BuildRequires: tiles
BuildRequires: tomcat5-jasper
BuildRequires: velocity14
BuildRequires: velocity-tools12
BuildRequires: xdoclet
BuildRequires: xjavadoc
BuildRequires: xml-commons-jaxp-1.3-apis
BuildRequires: xstream
BuildRequires: xwork >= 0:1.2.1

Requires: dwr
Requires: ecj
Requires: freemarker
Requires: jakarta-commons-collections
Requires: jakarta-commons-fileupload
Requires: jakarta-commons-io
Requires: jakarta-commons-lang
Requires: jakarta-commons-logging
Requires: jasperreports >= 0:1.0.0
Requires: jcommon
Requires: jetty5
Requires: jfreechart
Requires: jsp_2_0_api
Requires: nanocontainer-nanowar
Requires: ognl
Requires: oscore
Requires: pell-multipart
Requires: picocontainer
Requires: plexus-container-default
Requires: portlet_1_0_api
Requires: rife-continuations
Requires: servlet_2_4_api
Requires: sitemesh >= 0:2.4.1
Requires: spring-beans
Requires: spring-context
Requires: spring-core
Requires: spring-web
Requires: struts-tiles
Requires: velocity14
Requires: xml-commons-jaxp-1.3-apis
Requires: xstream
Requires: xwork >= 0:1.2.1
%if %{gcj_support}
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif

%description
WebWork is a Java web-application development framework. 
It is built specifically with developer productivity and 
code simplicity in mind. WebWork is built on top of XWork, 
which provides a generic command pattern framework as well 
as an Inversion of Control container. In addition to these 
features, WebWork provides robust support for building 
reusable UI templates, such as form controls, UI themes, 
internationalization, dynamic form parameter mapping to 
JavaBeans, robust client and server side validation, 
and much more. 

%package multipart
Summary:        Multipart support for %{name}
Group:          Development/Java
Requires: pell-multipart

%description multipart
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
BuildArch: noarch

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation
BuildArch: noarch

%description manual
%{summary}.

%prep
%setup -q 
for j in $(find . -name "*.jar"); do
  mv $j $j.no
done
mv lib/source/xwork-src.jar.no lib/source/xwork-src.jar
# Remove example with db4o, this lib is non-free, commercial only
rm -rf src/main/webwork/examples/userreg
# Remove cos-multipart implementation, pell-multipart will do it
rm src/java/com/opensymphony/webwork/dispatcher/multipart/CosMultiPartRequest.java
####cp src/example/log4j.properties src/test/log4j.properties
# this test fails
rm src/test/com/opensymphony/webwork/interceptor/TokenSessionStoreInterceptorTest.java

%patch0
%patch1
%patch2
%patch3
%patch4
%patch5
%patch6

# old xmlunit :(
rm ./src/test/com/opensymphony/webwork/views/jsp/ui/AbstractRichtexteditorTest.java
rm ./src/test/com/opensymphony/webwork/views/jsp/ui/RichtexteditorGetFoldersResultTest.java
rm ./src/test/com/opensymphony/webwork/views/jsp/ui/RichtexteditorGetFoldersAndFilesResultTest.java
rm ./src/test/com/opensymphony/webwork/views/jsp/ui/Richtexteditor*.java

rm ./src/test/com/opensymphony/webwork/dispatcher/json/XMLTest.java


%build
export OPT_JAR_LIST="ant/ant-nodeps ant/ant-trax ant/ant-junit junit"
pushd lib/ajax
ln -sf $(build-classpath dwr)
popd
pushd lib/bootstrap
#lib/bootstrap/clover-license.jar.no
ln -sf $(build-classpath commons-cli)
ln -sf $(build-classpath commons-codec)
ln -sf $(build-classpath commons-httpclient)
ln -sf $(build-classpath commons-logging)
ln -sf $(build-classpath ivy)
popd
pushd lib/build
#lib/build/clover.jar.no
ln -sf $(build-classpath easymock-classextension)
ln -sf $(build-classpath easymock)
ln -sf $(build-classpath jmock-cglib)
ln -sf $(build-classpath jmock)
ln -sf $(build-classpath junit)
ln -sf $(build-classpath mockobjects-jdk1.4-j2ee1.4)
ln -sf $(build-classpath mockobjects-alt-jdk1.4)
ln -sf $(build-classpath mockobjects-jdk1.4)
ln -sf $(build-classpath mockobjects-core)
ln -sf $(build-classpath servlet_2_3_api)
ln -sf $(build-classpath xdoclet/xdoclet)
ln -sf $(build-classpath xdoclet/xdoclet-web-module)
ln -sf $(build-classpath xjavadoc)
ln -sf $(build-classpath xmlunit)
popd
pushd lib/cewolf
ln -sf $(build-classpath cewolf) 
popd
pushd lib/default
ln -sf $(build-classpath commons-logging)
ln -sf $(build-classpath freemarker)
ln -sf $(build-classpath javamail_1_3_1_api) javamail.jar
ln -sf $(build-classpath javassist)
ln -sf $(build-classpath ognl)
ln -sf $(build-classpath oscore)
ln -sf $(build-classpath rife-continuations)
ln -sf $(build-classpath xwork)
popd
pushd lib/fileupload
ln -sf $(build-classpath commons-fileupload)
popd
pushd lib/fileupload-cos
#lib/fileupload-cos/cos.jar.no
popd
pushd lib/fileupload-pell
ln -sf $(build-classpath pell-multipart) multipartrequest.jar
popd
pushd lib/hibernate
ln -sf $(build-classpath antlr)
ln -sf $(build-classpath asm/asm)
ln -sf $(build-classpath cglib)
ln -sf $(build-classpath commons-collections)
ln -sf $(build-classpath commons-logging)
ln -sf $(build-classpath dom4j)
ln -sf $(build-classpath ehcache)
ln -sf $(build-classpath hibernate3) hibernate.jar
popd
pushd lib/jasperreports
ln -sf $(build-classpath commons-beanutils)
ln -sf $(build-classpath commons-collections)
ln -sf $(build-classpath commons-digester)
ln -sf $(build-classpath itext)
ln -sf $(build-classpath jasperreports)
ln -sf $(build-classpath poi)
popd
pushd lib/jfree
ln -sf $(build-classpath jcommon)
ln -sf $(build-classpath jfreechart)
popd
pushd lib/pico
ln -sf $(build-classpath nanocontainer/container) nanocontainer.jar
ln -sf $(build-classpath nanocontainer-nanowar)
ln -sf $(build-classpath picocontainer-gems)
ln -sf $(build-classpath picocontainer)
popd
pushd lib/plexus
ln -sf $(build-classpath classworlds)
ln -sf $(build-classpath plexus/container-default)
ln -sf $(build-classpath plexus/utils)
popd
pushd lib/portlet
ln -sf $(build-classpath portlet_1_0_api) portlet-api.jar
popd
pushd lib/quickstart
ln -sf $(build-classpath ant)
ln -sf $(build-classpath commons-collections)
ln -sf $(build-classpath commons-el)
ln -sf $(build-classpath commons-io)
ln -sf $(build-classpath commons-lang)
ln -sf $(build-classpath jasper5-compiler) jasper-compiler.jar
ln -sf $(build-classpath ecj) jasper-compiler-jdt.jar
ln -sf $(build-classpath jasper5-runtime) jasper-runtime.jar
ln -sf $(build-classpath jsp_2_0_api) jsp-api.jar
ln -sf $(build-classpath log4j)
ln -sf $(build-classpath jetty5/jetty5) org.mortbay.jetty.jar
ln -sf $(build-classpath servlet_2_4_api) servlet-api.jar
ln -sf $(build-classpath xstream)
popd
pushd lib/sitemesh
ln -sf $(build-classpath sitemesh)
popd
pushd lib/source
#lib/source/xwork-src.jar.no
popd
pushd lib/spring
ln -sf $(build-classpath cglib-nodep)
ln -sf $(build-classpath commons-attributes-api)
ln -sf $(build-classpath commons-logging)
ln -sf $(build-classpath spring/aop) spring-aop.jar
ln -sf $(build-classpath spring/beans) spring-beans.jar
ln -sf $(build-classpath spring/context) spring-context.jar
ln -sf $(build-classpath spring/core) spring-core.jar
ln -sf $(build-classpath spring/mock) spring-mock.jar
ln -sf $(build-classpath spring/web) spring-web.jar
popd
pushd lib/tiger
ln -sf $(build-classpath xwork)
popd
pushd lib/tiles
ln -sf $(build-classpath commons-beanutils)
ln -sf $(build-classpath commons-digester)
ln -sf $(build-classpath struts-tiles)
ln -sf $(build-classpath tiles/api) tiles-api.jar
ln -sf $(build-classpath tiles/core) tiles-core.jar
popd
pushd lib/velocity
ln -sf $(build-classpath commons-collections)
ln -sf $(build-classpath velocity14) velocity-dep.jar
ln -sf $(build-classpath velocity-tools12-view) velocity-tools-view.jar
popd
pushd lib/xslt
ln -sf $(build-classpath xml-commons-jaxp-1.3-apis) dom.jar
ln -sf $(build-classpath jcommon)
popd

ant -Dant.build.javac.source=1.5 -Dant.build.javac.target=1.5 \
	-Dant.javadoc.maxmemory=128m \
	-Dbuild.sysclasspath=first dist

mkdir tmp
cd tmp
jar xf ../dist/%{name}-%{version}.jar
jar cf ../dist/%{name}-multipart-%{version}.jar \
com/opensymphony/webwork/dispatcher/multipart/JakartaMultiPartRequest\$1.class \
com/opensymphony/webwork/dispatcher/multipart/JakartaMultiPartRequest.class \
com/opensymphony/webwork/dispatcher/multipart/MultiPartRequest.class \
com/opensymphony/webwork/dispatcher/multipart/MultiPartRequestWrapper.class \
com/opensymphony/webwork/dispatcher/multipart/PellMultiPartRequest.class
rm \
com/opensymphony/webwork/dispatcher/multipart/JakartaMultiPartRequest\$1.class \
com/opensymphony/webwork/dispatcher/multipart/JakartaMultiPartRequest.class \
com/opensymphony/webwork/dispatcher/multipart/MultiPartRequest.class \
com/opensymphony/webwork/dispatcher/multipart/MultiPartRequestWrapper.class \
com/opensymphony/webwork/dispatcher/multipart/PellMultiPartRequest.class
jar cmf META-INF/MANIFEST.MF ../dist/%{name}-%{version}.jar *
rm -rf *
#
jar xf ../dist/dist/%{name}-nostatic-%{version}.jar
rm \
com/opensymphony/webwork/dispatcher/multipart/JakartaMultiPartRequest\$1.class \
com/opensymphony/webwork/dispatcher/multipart/JakartaMultiPartRequest.class \
com/opensymphony/webwork/dispatcher/multipart/MultiPartRequest.class \
com/opensymphony/webwork/dispatcher/multipart/MultiPartRequestWrapper.class \
com/opensymphony/webwork/dispatcher/multipart/PellMultiPartRequest.class
jar cmf META-INF/MANIFEST.MF ../dist/dist/%{name}-nostatic-%{version}.jar *
cd ..
rm -rf tmp

# hack to help match manuals on both arches;
# seems to be a bug in manual
rm -rf dist/docs/junit

%install

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}

install -m 644 dist/%{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 dist/%{name}-multipart-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-multipart-%{version}.jar
install -m 644 dist/dist/%{name}-nostatic-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-nostatic-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -m 644 dist/dist/%{name}-static-%{version}.zip $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr dist/webapps $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf build/dist/docs/api

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr dist/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp %{SOURCE1} $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/LICENSE.txt

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

# It is the file in the package named Thumbs.db or Thumbs.db.gz, 
# which is normally a Windows image thumbnail database. 
# Such databases are generally useless in packages and were usually 
# accidentally included by copying complete directories from the source tarball.
find $RPM_BUILD_ROOT \( -name 'Thumbs.db' -o -name 'Thumbs.db.gz' \) -print -delete

%files
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_datadir}/%{name}-%{version}
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-nostatic-%{version}.jar
%{_javadir}/%{name}-nostatic.jar
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-*%{version}.jar.*
%{_libdir}/gcj/%{name}/webflow-%{version}.jar.*
%endif
# hack; explicitly added docdir if not owned
%doc %dir %{_docdir}/%{name}-%{version}

%files multipart
%{_javadir}/%{name}-multipart*.jar

%files javadoc
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%doc %{_docdir}/%{name}-%{version}

%changelog
* Wed Nov 03 2010 Igor Vlasenko <viy@altlinux.ru> 0:2.2.7-alt2_1jpp5
- fixed build with new xmlunit; increased javadoc maxmemory

* Thu Apr 15 2010 Igor Vlasenko <viy@altlinux.ru> 0:2.2.7-alt1_1jpp5.qa1
- NMU (by repocop): the following fixes applied:
  * windows-thumbnail-database-in-package for webwork
  * postclean-05-filetriggers for spec file

* Sun Mar 07 2010 Igor Vlasenko <viy@altlinux.ru> 0:2.2.7-alt1_1jpp5
- new version

